functor
export
   LogTraceClass
import
   SiteClass
   GraphicSite
   Tk
   Browser
   System
define
   NameCell = {NewCell 0}

   proc{NewName N}
      O in
      {Exchange NameCell O N}
      N = O + 1       
   end
   class LogTraceClass from Tk.frame
      feat
	 graphicalSite
	 logicalSite
	 port
	 id 
	 id_canvas
	 node_canvas
      meth solve
	 Ans Sync in
	 {System.showInfo "Calculates the casual order"}
	 Ans = {Map {Dictionary.entries self.logicalSite}
		fun{$ Id#S}
		   Id#{S solve(Sync $)}
		end}
	 Sync = unit
	 
	 %% Sets the y pos for all entries. 
	 {System.showInfo "Sets the y pos for all entries"}
	 {ForAll Ans
	  proc{$ Id#Solv} Solvs in
	     Solvs = {Filter Solv fun{$ R} {Label R} == solve end}
	     {ForAll Solvs {Dictionary.get self.graphicalSite Id}}
	  end}

	 %% Moves all sends and unrelated
	 {System.showInfo "Moves all sends and unrelated entries"}
	 {ForAll{Dictionary.entries self.logicalSite}
	  proc{$ Id#S}Solvs in
	     Solvs = {S solveFix($)} 
	     {ForAll Solvs {Dictionary.get self.graphicalSite Id}}
	  end}
	 
	 %% Update the graphics. The nodes will first be printed here
	 {ForAll Ans proc{$ Id#_} {self.graphicalSite.Id printNodes} end}
	 
	 %% Connects the lines 
	 {ForAll Ans
	  proc{$ Id#Solv} Links in
	     Links = {Filter Solv fun{$ R} {Label R} == link end}
	     {ForAll Links
	      proc{$ link(From#S1 To#S2)}
		 if From \= notfound then
		    {self.graphicalSite.S2
		     createLine({self.graphicalSite.S1  getXY(From $)} To)}
		 end
	      end}
	  end}
	 
	 
	 
	 %% fixing the scrollregion after the solve.
	 local
	    [X0 Y0 X1 Y1]={self.node_canvas tkReturnListInt(bbox alltag $)}
	    [X2 Y2 X3 Y3]={self.id_canvas tkReturnListInt(bbox idtag $)}
	    B 
	 in
	    B = 50
	    {self.node_canvas tk(configure scrollregion:q({Min X0 X2} -B
							  Y0-B
							  {Max X1 X3}+B
							  Y1+B))}

	    {self.id_canvas tk(configure scrollregion:q({Min X0 X2} -B
							  Y2-B
							  {Max X1 X3}+B
							  Y3+B))}
	    
	    {self.node_canvas tk(yview moveto 1.0)}
	 end
      end
      meth tkInit(...) = M
	 S TMP_O
	 ScrY ScrX
	 IC
	 NC
      in
	 Tk.frame,M
	 self.id = {NewName}
	 ScrY = {New Tk.scrollbar tkInit(parent:self orient:v)}
	 ScrX = {New Tk.scrollbar tkInit(parent:self orient:h)}

	 self.id_canvas = {New Tk.canvas tkInit(parent:self  bg:white width:200 height:20)}
	 self.node_canvas = {New Tk.canvas tkInit(parent:self  width:200 height:100)}
	 {Tk.addYScrollbar self.node_canvas ScrY}
	 IC = self.id_canvas
	 NC =self.node_canvas
	 
	 TMP_O = {New class $
			 meth init skip end
			 meth handle(A1 A2 A3 <= none)
			    if A3 == none then 
			       {Tk.send o(IC xview A1 A2)}
			       {Tk.send o(NC xview A1 A2)} 
			    else
			       {Tk.send o(IC xview A1 A2 A3)}
			       {Tk.send o(NC xview A1 A2 A3)}
			    end
			 end
		      end
		  init}
	 {Tk.batch
	  [o(self.id_canvas configure xscrollcommand:s(ScrX set))
	   o(ScrX configure command:{New Tk.action tkInit(parent:ScrX
							  action:TMP_O#handle)})
	   
	  ]}

	 {Tk.batch [grid(self.id_canvas row:0 column:0 sticky:ew)
		    grid(self.node_canvas row:1 column:0 sticky:nsew)
		    grid(ScrX row:2 column:0  sticky:ew)
		    grid(ScrY row:0 column:1 rowspan:2 sticky:ewns)
		    grid(rowconfigure self 1 weight:1)
		    grid(columnconfigure self 0 weight:1)
		    
		    
		   ]}
	 self.logicalSite = {NewDictionary}
	 self.graphicalSite = {NewDictionary}
      end
      
      meth  send(to:To 'from':From nr:Nr msg:Msg) 
	 N = {NewName}
	 Dir = if {Dictionary.member self.graphicalSite To} andthen 
		  self.graphicalSite.From.x >  self.graphicalSite.To.x
	       then left else right end
      in
	 {self.graphicalSite.From send(id:N msg:Msg type:From short:Msg.1 dir:Dir)}
	 {self.logicalSite.From send(to:To 'from':From nr:Nr id:N)}
      end
      
      meth  receive(to:To 'from':From nr:Nr msg:Msg) 
	 N = {NewName}
	 Dir = if {Dictionary.member self.graphicalSite From} andthen 
		  self.graphicalSite.From.x <  self.graphicalSite.To.x
	       then left else right end
      in
	 {self.graphicalSite.To receive(id:N msg:Msg type:To short:Msg.1 dir:Dir)}
	 {self.logicalSite.To receive(to:To 'from':From nr:Nr id:N)}
      end
      meth  string('from':From msg:Msg) 
	 N = {NewName} in
	 {self.graphicalSite.From string(id:N msg:Msg type:From)}
	 {self.logicalSite.From string(id:N)}
      end
      meth level 
	 Level in
	 {self solve}
	 Level = {FoldL {Dictionary.items self.logicalSite}
		  fun{$ Acc O} {Max Acc {O getlast($)}}
		  end 0} + 1 
	 {ForAll {Dictionary.items self.logicalSite}
	  proc{$ N} {N level(Level)} end}
	 {self solve}
      end

      meth event(E){Send self.port E} end
      meth addNode(ID C)
	 L = {Length  {Dictionary.entries self.logicalSite}}
	 S = {New SiteClass.siteClass init(ID)}
	 G = {New GraphicSite.graphicClass init(x:50 + L * 100
						canvas:self.node_canvas
						colorMapping:colors(ID:C))}
      in
	 {self.id_canvas tk(crea text 50 + L * 100 10 text:ID tags:idtag)}
	 {Dictionary.put self.logicalSite ID S}
	 {Dictionary.put self.graphicalSite ID G}
      end
      
   end
end

